#!/usr/bin/perl

#┌─────────────────────────────────
#│ JOYFUL NOTE : admin.cgi - 2021/07/24
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Smart Board Type-G v2.65 admin.cgi 2025/06/05
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session::ExpireSessions;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
err('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 条件分岐
if ($in{mente_log}) { mente_log(); }
if ($in{diary_mente}) { diary_mente(); }
if ($in{members} && $cf{authkey}) { members(); }
if ($in{exp_ses}) { exp_ses(); }
if ($in{pass_mgr}) { pass_mgr(); }
if ($in{mente_comment}) { mente_comment(); }
if ($in{apprv_log}) { apprv_log(); }
if ($in{info_mgr}) { info_mgr(); }

# 管理モード
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="ta-c">選択ボタンを押してください。</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="menu-tbl">
<tr>
	<th colspan="2">処理メニュー</th>
</tr><tr>
	<td class="ta-c"><input type="submit" name="mente_log" value="選択"></td>
	<td>&nbsp; 記事メンテナンス（修正/削除）</td>
</tr><tr>
	<td class="ta-c"><input type="submit" name="pass_mgr" value="選択"></td>
	<td>&nbsp; パスワード管理</td>
</tr><tr>
	<td class="ta-c"><input type="submit" name="diary_mente" value="選択"></td>
	<td>&nbsp; ダイアリー記事管理</td>
EOM

	if ($cf{approve} == 1) {
		print qq|</tr><tr>\n|;
		print qq|<td class="ta-c"><input type="submit" name="apprv_log" class="color cerulean-blue button" value="選択"></td>\n|;
		print qq|<td>&nbsp; コメントの承認/反映</td>\n|;
	}

	if ($cf{comment}) {
		print qq|</tr><tr>\n|;
		print qq|<td class="ta-c"><input type="submit" name="mente_comment" class="color cerulean-blue button" value="選択"></td>\n|;
		print qq|<td>&nbsp; コメント返信の削除</td>\n|;
	}

	if ($cf{authkey}) {
		print qq|</tr><tr>\n|;
		print qq|<td class="ta-c"><input type="submit" name="members" value="選択"></td>\n|;
		print qq|<td>&nbsp; 会員管理（認証モード）</td>\n|;

		print qq|</tr><tr>\n|;
		print qq|<td class="ta-c"><input type="submit" name="exp_ses" value="選択"></td>\n|;
		print qq|<td>&nbsp; session file削除 [not admin-mode]</td>\n|;

	}

	print <<EOM;
</tr><tr>
	<td class="ta-c"><input type="submit" name="info_mgr" class="color cerulean-blue button" value="選択"></td>
	<td>&nbsp; お知らせ管理</td>
</tr>
</tr><tr>
	<td class="ta-c"><input type="button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>&nbsp; ログアウト（掲示板移動）</td>
</tr>
</table>
</form>
</div></div>
</body>
</html>
EOM

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  お知らせ管理
#-----------------------------------------------------------
sub info_mgr {
	# 対象ファイル判定
	$cf{info} = "$cf{datadir}/side.dat";

	# --- 編集実行
	if ($in{edit}) {
		# 改行
		$in{body} =~ s/\r\n/\n/g;
		$in{body} =~ s/\r/\n/g;
		$in{body} =~ s/\t/\n/g;

		# タグ復元
		$in{body} = chg_tag($in{body});

		# 更新
		open(DAT,"> $cf{info}") or error("write err: $cf{info}");
		print DAT $in{body};
		close(DAT);

		# 完了画面
		message('編集を完了しました','side_mgr');
	}

	# 対象ファイル読み込み
	open(IN,"$cf{info}") or error("open err: $cf{info}");
	my $info = join('',<IN>);
	close(IN);

	# 画面表示
	header("お知らせ管理");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
EOM
	back_btn();
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="sub-ttl"><img src="$cf{toolurl}/apl_side.png" class="icon"> お知らせ管理</div>
<p>・ お知らせの編集を行います。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="info_mgr" value="1">
<table class="list">
<tr>
	<th class="ta-c">内容</th>
	<td>
		<input type="checkbox" onclick="toggleHtmlEditor(this.checked,'myArea3','full')" />エディター(NicEdit日本語版)<br />
		<textarea name="body" style="width:850px;height:25em;" id="myArea3">$info</textarea>
	</td>
</tr>
</table>
<input type="submit" name="edit" value="編集する" class="bigbtn">
</form>
</div>
</div>
EOM

	# nicEdit実行タグ
	nic_edit();

	footer();
}

#-----------------------------------------------------------
#  nicEdit定義
#-----------------------------------------------------------
sub nic_edit {
	print <<'EOM';
<script>
var html_editor = new Array();
var html_editor_loaded = false;
function loadHtmlEditor() {
	if (!html_editor_loaded) {
		var scripts = document.getElementsByTagName('script');
		for (var i=0; i<scripts.length; i++) {
			if (scripts[i].src.search(/nicEdit\.js$/) != -1) return true;
		}
		var header = document.getElementsByTagName('head')[0];
		var loader = document.createElement('script');
		loader.setAttribute('type','text/javascript');
EOM

	# パス指定
	print qq|loader.setAttribute('src','$cf{jsurl}/nicEdit.js');\n|;

	print <<'EOM';
		header.appendChild(loader);
		html_editor_loaded = true;
	}
}
function updateHtmlEditor(this_id) {
	if (html_editor[this_id] != null) {
		html_editor[this_id].updateInstance(this_id);
	}
}
function toggleHtmlEditor(open,this_id,panel_type) {
	if (open) {
		if (typeof nicEditor == "undefined") {
			loadHtmlEditor();
			setTimeout(function() { toggleHtmlEditor(open,this_id,panel_type) },500);
		} else {
			if (html_editor[this_id] == null) html_editor[this_id] = new nicEditor({panelType : panel_type}).panelInstance(this_id);
		}
	} else if (html_editor[this_id] != null) {
		html_editor[this_id].removeInstance(this_id);
		html_editor[this_id] = null;
	}
}
</script>
EOM
}

#-----------------------------------------------------------
#  コメント返信の承認・反映
#-----------------------------------------------------------
sub apprv_log {
	# 承認
	if ($in{job} eq 'aprv' && $in{no}) {

		my @data;
		foreach ( split(/\0/, $in{no}) ) {
			open(IN,"$cf{logdir}/$_.cgi");
			my $log = <IN>;
			close(IN);

			push(@data,$log);
		}

	# 連番読み込み
	open(DAT,"+< $cf{resnum}");
	eval "flock(DAT, 2);";
	my $number = <DAT>;
	seek(DAT, 0, 0);
	print DAT $number;
	truncate(DAT, tell(DAT));
	close(DAT);

		my @log;
		open(DAT,"+< $cf{reslog}") or cgi_err("open err: $cf{reslog}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);
				push(@log,$_);
		}

		foreach (@data) {
			unshift(@log,"$number<>$_\n");
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

	# TOPレスカウント更新
	top_rescnt();

		# 一時ファイル削除
		foreach ( split(/\0/,$in{no}) ) {
			unlink("$cf{logdir}/$_.cgi");
		}

	# 削除
	} elsif ($in{job} eq 'dele' && $in{no}) {
		foreach ( split(/\0/,$in{no}) ) {
			unlink("$cf{logdir}/$_.cgi");
		}
	}

	# クッキー格納
	set_cookie($in{name},$in{url}) if ($in{cookie});

	# コメント返信の承認/反映画面を表示
	header("コメント返信の承認/反映");
	back_btn('apprv_log');
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面 ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="sub-ttl"> コメント返信の承認/反映</div>
<ul>
<li>「承認」又は「削除」を選択して送信ボタンを押してください。やり直しはできないので慎重に！
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="apprv_log" value="1">
<input type="hidden" name="sid" value="$in{sid}">
処理：
<select name="job">
<option value="aprv">承認
<option value="dele">削除
</select>
<input type="submit" value="送信する">
EOM

	opendir(DIR,"$cf{logdir}");
	while( $_ = readdir(DIR) ) {
		next if (!/^(\d+)\.cgi$/);

		my $num = $1;
		open(IN,"$cf{logdir}/$num.cgi");
		my $log = <IN>;
		close(IN);

		my ($ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/,$log);
		print qq|<div class="art"><input type="checkbox" name="no" value="$num">\n|;
		print qq|<strong>$sub</strong> 投稿者：<b>$name</b> 投稿日：$date [ <span>$host</span> ]\n|;
		print qq|<div class="com">$com</div>\n|;
		if ($ex) {
			my $size = get_size("$cf{r_upldir}/$num$ex");
			print qq|<dd>添付|;
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[<span class=\"grn\">承認済</span>]"; } else { print "[<span class=\"red\">未承認</span>]"; }
			}
			print qq|：<a href="$cf{r_uplurl}/$num$ex" target="_blank">$num$ex</a> ($size)</div>\n|;
		}
	}
	closedir(DIR);

	print <<EOM;
</form>
<hr class="bottom">
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-------------------------------------------------
#  コメント返信メンテナンス
#-------------------------------------------------
sub mente_comment {

	# ページ数
	my $page = $in{page} || '0';
	foreach ( $cgi->param() ) {
		if (/^page:(\d+)$/) {
			$page = $1;
			last;
		}
	}

	# 削除処理
	if ($in{'no'}) {

		# 削除情報
		my %del;
		foreach ( split(/\0/, $in{'no'}) ) {
			$del{$_} = 1;
		}

		# 返信ログオープン
		my @data;
		open(DAT,"+< $cf{reslog}");
		eval "flock(DAT, 2);";
		while (<DAT>) {

			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

			if (defined($del{$no})) {

				# 画像削除
				if ($ex) { unlink("$cf{r_upldir}/$no$ex"); }

				next;
			}

			push(@data,$_);
		}

		# 返信ログ更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 採番
	open(DAT,"+< $cf{resnum}");
	eval "flock(DAT, 2);";
	my $num = <DAT> - 1;
	seek(DAT, 0, 0);
	print DAT $num;
	truncate(DAT, tell(DAT));
	close(DAT);

	# TOP用レスカウント更新
	top_rescnt();

	}

	header("管理メニュー &gt; コメント返信の削除");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
EOM
	back_btn('mente_res');
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="sub-ttl"> コメント返信の削除</div>
<blockquote>
・削除するコメントを選択し、削除ボタンを押してください。
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_comment" value="1">
<input type="submit" class="large button" value="削除する"">
</blockquote>
<div class="center">
<table class="edit-fm">
<tr>
  <th>選択</th>
  <th>[No.] 返信投稿日時</th>
  <th>親記事タイトル(投稿日)</th>
  <th>返信投稿者</th>
  <th class="mobile">コメント</th>
  <th class="mobile">添付</th>
</tr>
EOM

	# 記事
	my %sub;
	open(IN,"$cf{diarylog}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$ico,$color2,$wico,$diary) = split(/<>/);
			$sub{$no} = "<b style=\"color:#008db7\">$sub</b> (<span style=\"color:#a688bd\">$date</span>)";
	}
	close(IN);

	# コメント返信
	my $i = 0;
	open(IN,"$cf{reslog}");
	while(<IN>) {
		$i++;
		my ($num,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

		next if ($i < $page + 1);
		next if ($i > $page + $cf{max_thread});

		$com =~ s/<[^>]*(>|$)//g;
		if (length($com) > 45) {
			$com = substr($com,0,45) . ' <span style="color:#941f57">.......(略)</span>';
		}

		print qq |<tr><td width="60px"><input type="checkbox" name="no" value="$num"></td>|;
		print qq |<td width="260px">[$num] <soan style="color:green">$date</span></td>|;
		print qq |<td width="450px">$sub{$ent}</td>|;
		print qq |<td width="95px">$name</td>|;
		print qq |<td width="340px "class="mobile"><div class="com">$com</div></td>|;

		if ($ex) {
			my $size = get_size("$cf{r_upldir}/$num$ex");
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[○]"; } else { print "[×]"; }
			}
			print qq |<td width="180px"class="mobile"><div class="ext">添付:|;
			print qq |<a href="$cf{r_uplurl}/$num$ex" target="_blank">$num$ex</a> ($size)</div></div></td></tr>\n|;
		} else {
			print qq |<td width="180px""class="mobile"><div class="ext">添付なし</div></div></td></tr>\n|;
		}
	}
	close(IN);

	if ($i == 0) {
		print qq |<td align="center" colspan="5"><font size="-1">コメント返信がありません</font></td>|;
	}

	my $next = $page + $cf{max_thread};
	my $back = $page - $cf{max_thread};

	if ($back >= 0) {
		print qq|<input type="submit" name="page:$back" value="前画面" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;"><br><br>\n|;
	}
	if ($next < $i) {
		print qq|<input type="submit" name="page:$next" value="次画面" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;"><br><br>\n|;
	}

	print <<EOM;
</div>
</table>
</form>
<hr class="bottom">
</div></div></div>
</body></html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-------------------------------------------------
#  TOP用レスカウント更新
#-------------------------------------------------
sub top_rescnt {

	# コメントログ
	my (%res, @data);
	open(DB,"$cf{reslog}");
	while( my $db = <DB> ) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/, $db);
		$res{$ent}++;
	}
	close(DB);

	# 記事ログ
	open(DB,"$cf{logfile}");
	while( my $db = <DB> ) {
		chomp($db);
		my ($no,$date,$name) = split(/<>/, $db);

		if (!defined($res{$no})) { $res{$no} = 0; }
		push(@data,"$no<>$date<>$name<>$res{$no}<>\n");

	}
	close(DB);

	# index更新
	open(DAT,"+< $cf{rescnt}");
	eval "flock(DAT, 2);";
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  記事管理
#-----------------------------------------------------------
sub mente_log {
	# 修正フォーム
	if ($in{job} eq "edit" && $in{no}) {

		my @log;
		open(DAT,"$cf{logfile}") or err("open err: $cf{logfile}");
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($name,$eml,$sub,$com,$url,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock);
				last;
			}
		}
		close(DAT);

		if (@log == 0) { err("該当記事は存在しません"); }

		# 修正フォーム
		edit_form(@log);

	# 修正実行
	} elsif ($in{job} eq "edit2") {

		# 入力値補正
		if ($in{url} eq 'http://') { $in{url} = ''; }
		$in{sub} ||= '無題';

	# YouTubeタグに改行がある場合は排除
	$in{youtube} =~ s/\n//g;

		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3}|| $in{upfile4}|| $in{upfile5} || $in{upfile6} || $in{upfile7} || $in{upfile8} || $in{upfile9} || $in{upfile10} || $in{upfile11}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n) = add_upload($in{no});
		}

		# データオープン
		my (@data,$ext2,$w2,$h2);
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock) = split(/<>/);

			if ($no == $in{no}) {

			# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{imgdir}/$no-1$e1");
					unlink("$cf{imgdir}/$no-s-1$e1") if (-f "$cf{imgdir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{imgdir}/$no-2$e2");
					unlink("$cf{imgdir}/$no-s-2$e2") if (-f "$cf{imgdir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{imgdir}/$no-3$e3");
					unlink("$cf{imgdir}/$no-s-3$e3") if (-f "$cf{imgdir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{imgdir}/$no-4$e4");
					unlink("$cf{imgdir}/$no-s-4$e4") if (-f "$cf{imgdir}/$no-s-4$e4");
					$e4 = $w4 = $h4 = "";
				}
				if ($in{del5}) {
					unlink("$cf{imgdir}/$no-5$e5");
					unlink("$cf{imgdir}/$no-s-5$e5") if (-f "$cf{imgdir}/$no-s-5$e5");
					$e5 = $w5 = $h5 = "";
				}
				if ($in{del6}) {
					unlink("$cf{imgdir}/$no-6$e6");
					unlink("$cf{imgdir}/$no-s-6$e6") if (-f "$cf{imgdir}/$no-s-6$e6");
					$e6 = $w6 = $h6 = "";
				}
				if ($in{del7}) {
					unlink("$cf{imgdir}/$no-7$e7");
					unlink("$cf{imgdir}/$no-s-7$e7") if (-f "$cf{imgdir}/$no-s-7$e7");
					$e7 = $w7 = $h7 = "";
				}
				if ($in{del8}) {
					unlink("$cf{imgdir}/$no-8$e8");
					unlink("$cf{imgdir}/$no-s-8$e8") if (-f "$cf{imgdir}/$no-s-8$e8");
					$e8 = $w8 = $h8 = "";
				}
				if ($in{del9}) {
					unlink("$cf{imgdir}/$no-9$e9");
					unlink("$cf{imgdir}/$no-s-9$e9") if (-f "$cf{imgdir}/$no-s-9$e9");
					$e9 = $w9 = $h9 = "";
				}
				if ($in{del10}) {
					unlink("$cf{imgdir}/$no-10$e10");
					unlink("$cf{imgdir}/$no-s-10$e10") if (-f "$cf{imgdir}/$no-s-10$e10");
					$e10 = $w10 = $h10 = "";
				}
				if ($in{del11}) {
					unlink("$cf{imgdir}/$no-11$e11");
					unlink("$cf{imgdir}/$no-s-11$e11") if (-f "$cf{imgdir}/$no-s-11$e11");
					$e11 = $w11 = $h11 = "";
				}

				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{imgdir}/$no-1$e1");
					unlink("$cf{imgdir}/$no-s-1$e1") if (-f "$cf{imgdir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{imgdir}/$no-2$e2");
					unlink("$cf{imgdir}/$no-s-2$e2") if (-f "$cf{imgdir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{imgdir}/$no-3$e3");
					unlink("$cf{imgdir}/$no-s-3$e3") if (-f "$cf{imgdir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{imgdir}/$no-4$e4");
					unlink("$cf{imgdir}/$no-s-4$e4") if (-f "$cf{imgdir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{imgdir}/$no-5$e5");
					unlink("$cf{imgdir}/$no-s-5$e5") if (-f "$cf{imgdir}/$no-s-5$e5");
				}
				if ($e6n && $e6n ne $e6) {
					unlink("$cf{imgdir}/$no-6$e6");
					unlink("$cf{imgdir}/$no-s-6$e6") if (-f "$cf{imgdir}/$no-s-6$e6");
				}
				if ($e7n && $e7n ne $e7) {
					unlink("$cf{imgdir}/$no-7$e7");
					unlink("$cf{imgdir}/$no-s-7$e7") if (-f "$cf{imgdir}/$no-s-7$e7");
				}
				if ($e8n && $e8n ne $e8) {
					unlink("$cf{imgdir}/$no-8$e8");
					unlink("$cf{imgdir}/$no-s-8$e8") if (-f "$cf{imgdir}/$no-s-8$e8");
				}
				if ($e9n && $e9n ne $e9) {
					unlink("$cf{imgdir}/$no-9$e9");
					unlink("$cf{imgdir}/$no-s-9$e9") if (-f "$cf{imgdir}/$no-s-9$e9");
				}
				if ($e10n && $e10n ne $e10) {
					unlink("$cf{imgdir}/$no-10$e10");
					unlink("$cf{imgdir}/$no-s-10$e10") if (-f "$cf{imgdir}/$no-s-10$e10");
				}
				if ($e11n && $e11n ne $e11) {
					unlink("$cf{imgdir}/$no-11$e11");
					unlink("$cf{imgdir}/$no-s-11$e11") if (-f "$cf{imgdir}/$no-s-11$e11");
				}

				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e5n; $w5 = $w5n; $h5 = $h5n; }
				if ($e6n) { $e6 = $e6n; $w6 = $w6n; $h6 = $h6n; }
				if ($e7n) { $e7 = $e7n; $w7 = $w7n; $h7 = $h7n; }
				if ($e8n) { $e8 = $e8n; $w8 = $w8n; $h8 = $h8n; }
				if ($e9n) { $e9 = $e9n; $w9 = $w9n; $h9 = $h9n; }
				if ($e10n) { $e10 = $e10n; $w10 = $w10n; $h10 = $h10n; }
				if ($e11n) { $e11 = $e11n; $w11 = $w11n; $h11 = $h11n; }

				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$e1<>$w1<>$h1<>0<>$myid<>$in{color2}<>$in{youtube}<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$in{tubeid}<>$in{icon}<>$wico<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$in{imgtext7}<>$in{imgtext8}<>$in{imgtext9}<>$in{imgtext10}<>$in{imgtext11}<>$lock<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		msg_edit("修正が完了しました");

	# スレッドロック開閉
	} elsif ($in{job} eq "lock" && $in{no}) {

		# データオープン
		my @data;
		open(DAT,"+< $cf{logfile}") or err_msg("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock) = split(/<>/);

			# スレッドロック開閉
			if ($in{no} == $no) {
				if ($lock == 0) { $lock = 1; } else { $lock = 0; }
				$_ = "$no<>$reno<>$date<>$name<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$col<>$e1<>$w1<>$h1<>$chk<>$myid<>$color2<>$tube<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$tubeid<>$ico<>$wico<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>$imgtxt6<>$imgtxt7<>$imgtxt8<>$imgtxt9<>$imgtxt10<>$imgtxt11<>$lock<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事のロック開閉を調整しました");

	# 削除処理
	} elsif ($in{job} eq "dele" && $in{no}) {

		# 削除
		my @data;
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock) = split(/<>/);

			if ($in{no} == $no || $in{no} == $reno) {

				# 添付ファイル削除
				if ($e1) {
					unlink("$cf{imgdir}/$no-1$e1");
					unlink("$cf{imgdir}/$no-s-1$e1") if (-f "$cf{imgdir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{imgdir}/$no-2$e2");
					unlink("$cf{imgdir}/$no-s-2$e2") if (-f "$cf{imgdir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{imgdir}/$no-3$e3");
					unlink("$cf{imgdir}/$no-s-3$e3") if (-f "$cf{imgdir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{imgdir}/$no-4$e4");
					unlink("$cf{imgdir}/$no-s-4$e4") if (-f "$cf{imgdir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{imgdir}/$no-5$e5");
					unlink("$cf{imgdir}/$no-s-5$e5") if (-f "$cf{imgdir}/$no-s-5$e5");
				}
				if ($e6) {
					unlink("$cf{imgdir}/$no-6$e6");
					unlink("$cf{imgdir}/$no-s-6$e6") if (-f "$cf{imgdir}/$no-s-6$e6");
				}
				if ($e7) {
					unlink("$cf{imgdir}/$no-7$e7");
					unlink("$cf{imgdir}/$no-s-7$e7") if (-f "$cf{imgdir}/$no-s-7$e7");
				}
				if ($e8) {
					unlink("$cf{imgdir}/$no-8$e8");
					unlink("$cf{imgdir}/$no-s-8$e8") if (-f "$cf{imgdir}/$no-s-8$e8");
				}
				if ($e9) {
					unlink("$cf{imgdir}/$no-9$e9");
					unlink("$cf{imgdir}/$no-s-9$e9") if (-f "$cf{imgdir}/$no-s-9$e9");
				}
				if ($e10) {
					unlink("$cf{imgdir}/$no-10$e10");
					unlink("$cf{imgdir}/$no-s-10$e10") if (-f "$cf{imgdir}/$no-s-10$e10");
				}
				if ($e11) {
					unlink("$cf{imgdir}/$no-11$e11");
					unlink("$cf{imgdir}/$no-s-11$e11") if (-f "$cf{imgdir}/$no-s-11$e11");
				}
				next;
			}
			push(@data,$_);
		}
		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 画像許可
	} elsif ($in{job} eq "perm" && $in{no}) {

		# 許可情報をマッチングし更新
		my @data;
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock) = split(/<>/);

			if ($no == $in{no}) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$reno<>$date<>$name<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$col<>$e1<>$w1<>$h1<>$chk<>$myid<>$color2<>$tube<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$tubeid<>$ico<>$wico<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$in{imgtext7}<>$in{imgtext8}<>$in{imgtext9}<>$in{imgtext10}<>$in{imgtext11}<>$lock<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	# 管理を表示
	header("記事メンテナンス（修正/削除）");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
EOM
	back_btn();
	print <<"EOM";
</div>
<div class="sub-ttl"> 記事メンテナンス（修正/削除）</div>
<br />
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_log" value="1">
※処理を選択してください<br>
処理：
<select name="job">
<option value="edit">編集</option>
<option value="dele">削除</option>
<option value="lock">ロック</option>
EOM

	if ($cf{img_check}) {
		print qq|<option value="perm">許可</option>\n|;
	}

	print <<EOM;
</select>
<input type="submit" value="送信する">
<dl class="log">
EOM

	open(IN,"$cf{logfile}") or err("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11,$lock) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com = auto_link($com) if ($cf{auto_link});

	my @col = split(/\s+/, $cf{colors});

		print qq|<div align="center">\n|;
		if (!$reno) {
			print qq|<div class="main" style="border-color:$color2;">|;
		} else {
			print qq|<div class="sub" style="border-color:$color2;">|;
		}

		print qq|<b id="flag-sample" style="background:$color2;">$sub</b>\n|;
		print qq|<div class="info"><input type="radio" name="no" value="$no">[$no]\n|;

		if ($lock == 1) {
			print qq|<img src="cmn/lock02s.png" height="24px" class="clip" alt="" />&nbsp;&nbsp;|;
		}

		print qq|<span style="line-height:100%; margin-top:5mm; margin-bottom:5mm;">&nbsp;&nbsp;名前：<b>$name</b> 日時：$date\n|;
		print qq|[$host]\n|;
		print qq|&nbsp;[ID:$myid]<br />| if ($cf{authkey});
		if ($e1) {
			print qq|[<a href="$cf{imgdir}/$no-1$e1" target="_blank">添付</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt1 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;<br>\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt1)</span> &nbsp;<br>\n|;
				}
		}
		if ($e2) {
			print qq|[<a href="$cf{imgdir}/$no-2$e2" target="_blank">追加添付 1</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt2 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt2)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e3) {
			print qq|[<a href="$cf{imgdir}/$no-3$e3" target="_blank">追加添付 2</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt3 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt3)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e4) {
			print qq|[<a href="$cf{imgdir}/$no-4$e4" target="_blank">追加添付 3</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt4 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt4)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e5) {
			print qq|[<a href="$cf{imgdir}/$no-5$e5" target="_blank">追加添付 4</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt5 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt5)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e6) {
			print qq|[<a href="$cf{imgdir}/$no-6$e6" target="_blank">追加添付 5</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt6 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt6)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e7) {
			print qq|[<a href="$cf{imgdir}/$no-7$e7" target="_blank">追加添付 6</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt7 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt7)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e8) {
			print qq|[<a href="$cf{imgdir}/$no-8$e8" target="_blank">追加添付 7</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt8 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt8)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e9) {
			print qq|[<a href="$cf{imgdir}/$no-9$e9" target="_blank">追加添付 8</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt9 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt9)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e10) {
			print qq|[<a href="$cf{imgdir}/$no-10$e10" target="_blank">追加添付 9</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt10 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt10)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e11) {
			print qq|[<a href="$cf{imgdir}/$no-11$e11" target="_blank">追加添付 10</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt11 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt11)</span> &nbsp;&nbsp;\n|;
				}
		}

		print qq|</span></div><div class="com"><span style="color:$col[$col]">$com</span></div>\n|;

		# タグ復元
		$tube =~ s/&lt;/</g;
		$tube =~ s/&gt;/>/g;
		$tube =~ s/&quot;/"/g;
		$tube =~ s/&amp;/&/g;

		# 親(YouTube)
		if ($cf{tube}) {
			$tubeid =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}
		print qq|$tubeid\n| if ($tubeid);
		print qq|<div class="clear"></div>\n|;
		print qq|<br /><div style="max-width: $cf{tubesize};"><div class="movie-wrap">$tube</div></div>\n| if ($tube);
		print qq|</div>\n|;
	}
	close(IN);

	print <<EOM;
</form><br /><br />
</div></div></div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	my ($name,$eml,$sub,$com,$url,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = @_;
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	#if ($color2 eq "") { $color2 = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $color2) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	# アイコン
	my @icon;
	foreach (@{$cf{icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@icon,$ico);
	}
	# アイコンプルダウン
	my @icon;
	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($ico eq $icon) {
			$op_icon .= qq|<option value="$icon" selected>$nam\n|;
		} else {
			$op_icon .= qq|<option value="$icon">$nam\n|;
		}
	}
        #セレクトアイコン
	my $selecticon;
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
        	if ($ico eq '') {
			$selecticon = $icon[0];
        	} else {
			$selecticon = $ico;
        	}

	header("管理モード &gt; 修正フォーム");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="&lt; 戻る">
</form>
</div>
<div class="sub-ttl"> 編集フォーム</div>
<p>▼変更する部分のみ修正して送信ボタンを押して下さい。</p>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_log" value="1">
<input type="hidden" name="job" value="edit2">
<input type="hidden" name="no" value="$in{no}">
<table class="form-tbl">
<tr>
	<th>名前</th>
	<td><input type="text" name="name" value="$name" size="30" class="reg-name"></td>
	<th>E-mail</th>
	<td><input type="text" name="email" value="$eml" size="30" class="reg-name"></td>
</tr><tr>
	<th>アイコン</th>
	<td colspan="4">
		<div id="Selected"><img id="imgchange" src="$cf{faceurl}/$selecticon" width="80px" height="80px" class="select" alt=""></div>
		<select name="icon" id="icon" onchange="iconchg();" />
		$op_icon
		</select>
	</td>
</tr><tr>
	<th>タイトル</th>
	<td><input type="text" name="sub" value="$sub" size="30" class="reg-ttl"></td>
	<th>旗色</th>
	<td>
		<select name="color2">
		$color_b
		</select>
	</td>
</tr><tr>
	<th>文字色</th>
	<td colspan="4">$color</td>
</tr><tr>
	<th>コメント</th>
	<td colspan="4"><textarea name="comment" class="reg-com">$com</textarea></td>

EOM
		print qq|</tr><tr>\n|;
		print qq|<th>添付</th><td colspan="4">\n|;
	if ($e1) {
		print qq|<input type="file" name="upfile1" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-1$e1" target="_blank">添付</a>]&nbsp;\n|;
		print qq|<input type="checkbox" name="del1" value="1">削除</td>\n|;
	} else {
		print qq|<input type="file" name="upfile1" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="25"><br />\n|;
	}

		print qq|</tr><tr>\n|;
		print qq|<th>追加添付</th><td colspan="4">\n|;
	if ($e2) {
		print qq|１．<input type="file" name="upfile2" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-2$e2" target="_blank">追加１</a>|;
		print qq|<input type="checkbox" name="del2" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|１．<input type="file" name="upfile2" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="25"><br /><hr class="edit">\n|;
	}

	if ($e3) {
		print qq|２．<input type="file" name="upfile3" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-3$e3" target="_blank">追加２</a>|;
		print qq|<input type="checkbox" name="del3" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|２．<input type="file" name="upfile3" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="25"><br /><hr class="edit">\n|;
	}

	if ($e4) {
		print qq|３．<input type="file" name="upfile4" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-4$e4" target="_blank">追加３</a>|;
		print qq|<input type="checkbox" name="del4" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|３．<input type="file" name="upfile4" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="25"><br /><hr class="edit">\n|;
	}

	if ($e5) {
		print qq|４．<input type="file" name="upfile5" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-5$e5" target="_blank">追加４</a>|;
		print qq|<input type="checkbox" name="del5" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|４．<input type="file" name="upfile5" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="25"><br /><hr class="edit">\n|;
	}

	if ($e6) {
		print qq|５．<input type="file" name="upfile6" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-6$e6" target="_blank">追加５</a>|;
		print qq|<input type="checkbox" name="del6" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|５．<input type="file" name="upfile6" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="25"><br /><hr class="edit">\n|;
	}

	if ($e7) {
		print qq|６．<input type="file" name="upfile7" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext7" class="reg-imgtxt" placeholder="追加添付６タイトル" value="$imgtxt7" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-7$e7" target="_blank">追加６</a>|;
		print qq|<input type="checkbox" name="del7" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|６．<input type="file" name="upfile7" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext7" class="reg-imgtxt" placeholder="追加添付６タイトル" value="$imgtxt7" size="25"><br /><hr class="edit">\n|;
	}

	if ($e8) {
		print qq|７．<input type="file" name="upfile8" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext8" class="reg-imgtxt" placeholder="追加添付７タイトル" value="$imgtxt8" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-8$e8" target="_blank">追加７</a>|;
		print qq|<input type="checkbox" name="del8" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|７．<input type="file" name="upfile8" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext8" class="reg-imgtxt" placeholder="追加添付７タイトル" value="$imgtxt8" size="25"><br /><hr class="edit">\n|;
	}

	if ($e9) {
		print qq|８．<input type="file" name="upfile9" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext9" class="reg-imgtxt" placeholder="追加添付８タイトル" value="$imgtxt9" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-9$e9" target="_blank">追加８</a>|;
		print qq|<input type="checkbox" name="del9" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|８．<input type="file" name="upfile9" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext9" class="reg-imgtxt" placeholder="追加添付８タイトル" value="$imgtxt9" size="25"><br /><hr class="edit">\n|;
	}

	if ($e10) {
		print qq|９．<input type="file" name="upfile10" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext10" class="reg-imgtxt" placeholder="追加添付９タイトル" value="$imgtxt10" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-10$e10" target="_blank">追加９</a>|;
		print qq|<input type="checkbox" name="del10" value="1">削除]<br /><hr class="edit">\n|;
	} else {
		print qq|９．<input type="file" name="upfile10" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext10" class="reg-imgtxt" placeholder="追加添付９タイトル" value="$imgtxt10" size="25"><br /><hr class="edit">\n|;
	}

	if ($e11) {
		print qq|10．<input type="file" name="upfile11" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext11" class="reg-imgtxt" placeholder="追加添付１０タイトル" value="$imgtxt11" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}-11$e11" target="_blank">追加10</a>|;
		print qq|<input type="checkbox" name="del11" value="1">削除]<br />\n|;
		print qq|<p></p></td>\n|;
	} else {
		print qq|10．<input type="file" name="upfile11" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext11" class="reg-imgtxt" placeholder="追加添付１０タイトル" value="$imgtxt11" size="25"><br />\n|;
		print qq|<p></p></td>\n|;
	}
	
	print <<EOM;

</tr><tr>
	<th>YouTube</th>
	<td colspan="4">YouTubeタグ [埋め込みコード]<br /><textarea name="youtube" class="reg-com" rows="7">$tube</textarea></td>
</tr><tr>
	<th>YouTube ID</th>
	<td colspan="4">
		<input type="text" name="tubeid" value="$tubeid" class="reg-com-tube">
		<a href="$cf{bbs_cgi}?mode=expound" class="expound" data-fancybox-type="iframe" title="YouTube貼付方法">【YouTube貼付方法】</a>
	</td>
</tr><tr>
	<th>URL</th>
	<td colspan="4"><input type="text" name="url" value="$url" class="reg-url"></td>
</tr><tr>
	<th></th>
	<td colspan="4">
		<input type="submit" class="regbtn_admin" value="送信する">
	</td>
</tr>
</table>
</form>
<hr class="bottom">
</div></div>
</body>
</html>
EOM

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  ダイアリー記事管理
#-----------------------------------------------------------
sub diary_mente {
	# 修正フォーム
	if ($in{job} eq "edit" && $in{no}) {

		my @log;
		open(DAT,"$cf{diarylog}") or err("open err: $cf{diarylog}");
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($name,$eml,$sub,$com,$url,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11);
				last;
			}
		}
		close(DAT);

		if (@log == 0) { err("該当記事は存在しません"); }

		# 修正フォーム
		diary_edit_form(@log);

	# 修正実行
	} elsif ($in{job} eq "edit2") {

		# 入力値補正
		if ($in{url} eq 'http://') { $in{url} = ''; }
		$in{sub} ||= '無題';

	# YouTubeタグに改行がある場合は排除
	$in{youtube} =~ s/\n//g;

		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3}|| $in{upfile4}|| $in{upfile5} || $in{upfile6} || $in{upfile7} || $in{upfile8} || $in{upfile9} || $in{upfile10} || $in{upfile11}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n) = diary_upload($in{no});
		}

		# データオープン
		my (@data,$ext2,$w2,$h2);
		open(DAT,"+< $cf{diarylog}") or err("open err: $cf{diarylog}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

			if ($no == $in{no}) {

			# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
					$e4 = $w4 = $h4 = "";
				}
				if ($in{del5}) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
					$e5 = $w5 = $h5 = "";
				}
				if ($in{del6}) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
					$e6 = $w6 = $h6 = "";
				}
				if ($in{del7}) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
					$e7 = $w7 = $h7 = "";
				}
				if ($in{del8}) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
					$e8 = $w8 = $h8 = "";
				}
				if ($in{del9}) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
					$e9 = $w9 = $h9 = "";
				}
				if ($in{del10}) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
					$e10 = $w10 = $h10 = "";
				}
				if ($in{del11}) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
					$e11 = $w11 = $h11 = "";
				}

				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
				}
				if ($e6n && $e6n ne $e6) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
				}
				if ($e7n && $e7n ne $e7) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
				}
				if ($e8n && $e8n ne $e8) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
				}
				if ($e9n && $e9n ne $e9) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
				}
				if ($e10n && $e10n ne $e10) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
				}
				if ($e11n && $e11n ne $e11) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
				}

				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e5n; $w5 = $w5n; $h5 = $h5n; }
				if ($e6n) { $e6 = $e6n; $w6 = $w6n; $h6 = $h6n; }
				if ($e7n) { $e7 = $e7n; $w7 = $w7n; $h7 = $h7n; }
				if ($e8n) { $e8 = $e8n; $w8 = $w8n; $h8 = $h8n; }
				if ($e9n) { $e9 = $e9n; $w9 = $w9n; $h9 = $h9n; }
				if ($e10n) { $e10 = $e10n; $w10 = $w10n; $h10 = $h10n; }
				if ($e11n) { $e11 = $e11n; $w11 = $w11n; $h11 = $h11n; }

				$_ = "$no<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$e1<>$w1<>$h1<>0<>$myid<>$in{color2}<>$in{youtube}<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$in{tubeid}<>$in{icon}<>$wico<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$in{imgtext7}<>$in{imgtext8}<>$in{imgtext9}<>$in{imgtext10}<>$in{imgtext11}<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		diary_edit("修正が完了しました");

	# 削除処理
	} elsif ($in{job} eq "dele" && $in{no}) {

		# 削除
		my @data;
		open(DAT,"+< $cf{diarylog}") or err("open err: $cf{diarylog}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

			if ($in{no} == $no) {

				# 添付ファイル削除
				if ($e1) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
				}
				if ($e6) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
				}
				if ($e7) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
				}
				if ($e8) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
				}
				if ($e9) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
				}
				if ($e10) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
				}
				if ($e11) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
				}
				next;
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 画像許可
	} elsif ($in{job} eq "perm" && $in{no}) {

		# 許可情報をマッチングし更新
		my @data;
		open(DAT,"+< $cf{diarylog}") or err("open err: $cf{diarylog}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

			if ($no == $in{no}) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$date<>$name<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$col<>$e1<>$w1<>$h1<>$chk<>$myid<>$color2<>$tube<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$tubeid<>$ico<>$wico<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$in{imgtext7}<>$in{imgtext8}<>$in{imgtext9}<>$in{imgtext10}<>$in{imgtext11}<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	# 管理を表示
	header("ダイアリー記事メンテナンス（修正/削除）");
	print <<EOM;
	<!-- Add jQuery library -->
	<script type="text/javascript" src="fancyBox/lib/jquery-1.10.1.min.js"></script>

	<!-- Add mousewheel plugin (this is optional) -->
	<script type="text/javascript" src="fancyBox/lib/jquery.mousewheel-3.0.6.pack.js"></script>

	<!-- Add fancyBox main JS and CSS files -->
	<script type="text/javascript" src="fancyBox/source/jquery.fancybox.js?v=2.1.5"></script>
	<link rel="stylesheet" type="text/css" href="fancyBox/source/jquery.fancybox.css?v=2.1.5" media="screen" />

	<!-- Add Button helper (this is optional) -->
	<link rel="stylesheet" type="text/css" href="fancyBox/source/helpers/jquery.fancybox-buttons.css?v=1.0.5" />
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-buttons.js?v=1.0.5"></script>

	<!-- Add Thumbnail helper (this is optional) -->
	<link rel="stylesheet" type="text/css" href="fancyBox/source/helpers/jquery.fancybox-thumbs.css?v=1.0.7" />
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-thumbs.js?v=1.0.7"></script>

	<!-- Add Media helper (this is optional) -->
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-media.js?v=1.0.6"></script>
	<script type="text/javascript" src="fancyBox/source/fancybox.js"></script>
	<script type="text/javascript" src="fancyBox/source/jquery.joyful.fancybox.js"></script>
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
EOM
	back_btn();
	print <<"EOM";
</div>
<div class="sub-ttl"> ダイアリー記事メンテナンス（修正/削除）</div>
<br />
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="diary_mente" value="1">
※処理を選択してください<br>
処理：
<select name="job">
<option value="edit">編集
<option value="dele">削除
EOM

	if ($cf{img_check}) {
		print qq|<option value="perm">許可\n|;
	}

	print <<EOM;
</select>
<input type="submit" value="送信する">
<dl class="log">
EOM

	open(IN,"$cf{diarylog}") or err("open err: $cf{diarylog}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com = auto_link($com) if ($cf{auto_link});

	my @col = split(/\s+/, $cf{colors});

		print qq|<div align="center">\n|;
		print qq|<div class="main" style="border-color:$color2;">|;
		print qq|<b id="flag-sample" style="background:$color2;">$sub</b>\n|;
		print qq|<div class="info"><input type="radio" name="no" value="$no"><span style="color:#e17b34">[$no]</span>\n|;
		print qq|<span style="line-height:100%; margin-top:5mm; margin-bottom:5mm;">&nbsp;&nbsp; 日時：<span style="color:#00a968">$date</span>\n|;
		print qq|[$host]\n|;
		print qq|&nbsp;[<b style="color:#9a0d7c">ID:$myid</b>]&nbsp;<img src="icon/weather/$wico" width="47px" height="30px" alt=""><br />| if ($cf{authkey});
		if ($e1) {
			print qq|[<a href="$cf{diaryimgdir}/$no-1$e1" target="_blank">添付</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt1 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;<br>\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt1)</span> &nbsp;<br>\n|;
				}
		}
		if ($e2) {
			print qq|[<a href="$cf{diaryimgdir}/$no-2$e2" target="_blank">追加添付 1</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt2 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt2)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e3) {
			print qq|[<a href="$cf{diaryimgdir}/$no-3$e3" target="_blank">追加添付 2</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt3 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt3)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e4) {
			print qq|[<a href="$cf{diaryimgdir}/$no-4$e4" target="_blank">追加添付 3</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt4 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt4)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e5) {
			print qq|[<a href="$cf{diaryimgdir}/$no-5$e5" target="_blank">追加添付 4</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt5 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt5)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e6) {
			print qq|[<a href="$cf{diaryimgdir}/$no-6$e6" target="_blank">追加添付 5</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt6 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt6)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e7) {
			print qq|[<a href="$cf{diaryimgdir}/$no-7$e7" target="_blank">追加添付 6</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt7 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt7)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e8) {
			print qq|[<a href="$cf{diaryimgdir}/$no-8$e8" target="_blank">追加添付 7</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt8 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt8)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e9) {
			print qq|[<a href="$cf{diaryimgdir}/$no-9$e9" target="_blank">追加添付 8</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt9 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt9)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e10) {
			print qq|[<a href="$cf{diaryimgdir}/$no-10$e10" target="_blank">追加添付 9</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt10 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt10)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($e11) {
			print qq|[<a href="$cf{diaryimgdir}/$no-11$e11" target="_blank">追加添付 10</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
				if ($imgtxt11 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt11)</span> &nbsp;&nbsp;\n|;
				}
		}

		print qq|</span></div><div class="com"><span style="color:$col[$col]">$com</span></div>\n|;

		# タグ復元
		$tube =~ s/&lt;/</g;
		$tube =~ s/&gt;/>/g;
		$tube =~ s/&quot;/"/g;
		$tube =~ s/&amp;/&/g;

		# 親(YouTube)
		if ($cf{tube}) {
			$tubeid =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}
		print qq|$tubeid\n| if ($tubeid);
		print qq|<div class="clear"></div>\n|;
		print qq|<br /><div style="max-width: $cf{tubesize};"><div class="movie-wrap">$tube</div></div>\n| if ($tube);
		print qq|</div>\n|;
	}
	close(IN);

	print <<EOM;
</form><br /><br />
</div></div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ダイアリー修正フォーム
#-----------------------------------------------------------
sub diary_edit_form {
	my ($name,$eml,$sub,$com,$url,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = @_;
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	# お天気マーク
	my @wicon;
	foreach (@{$cf{w_icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@wicon,$ico);
	}
	# お天気マークプルダウン
	my $op_weather;
	foreach (0 .. $#{$cf{w_icon}}) {
		my ($icon,$nam) = split(/,/, $cf{w_icon}->[$_]);
		if ($wicon[$_] eq $wico) {
			$op_weather .= qq|<option value="$wicon[$_]" selected>$nam\n|;
		} else {
			$op_weather .= qq|<option value="$wicon[$_]">$nam\n|;
		}
	}
        #セレクトお天気マーク
	my ($selectmark,$wicon);
        	if ($wico eq '') {
			$selectmark = $wicon[0];
        	} else {
			$selectmark = $wico;
        	}

	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	#if ($color2 eq "") { $color2 = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $color2) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	# アイコン
	my @icon;
	foreach (@{$cf{icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@icon,$ico);
	}
	# アイコンプルダウン
	my @icon;
	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($icon eq $ico) {
			$op_icon .= qq|<option value="$icon" selected>$nam\n|;
		} else {
			$op_icon .= qq|<option value="$icon">$nam\n|;
		}
	}
        #セレクトアイコン
	my $selecticon;
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
        	if ($ico eq '') {
			$selecticon = $icon[0];
        	} else {
			$selecticon = $ico;
        	}

	header("管理モード &gt; ダイアリー編集フォーム");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="&lt; 戻る">
</form>
</div>
<div class="sub-ttl"> ダイアリー編集フォーム</div>
<p>▼変更する部分のみ修正して送信ボタンを押して下さい。</p>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="diary_mente" value="1">
<input type="hidden" name="job" value="edit2">
<input type="hidden" name="no" value="$in{no}">
<table class="form-tbl">
<tr>
	<th>タイトル</th>
	<td><input type="text" name="sub" value="$sub" size="30" class="reg-ttl"></td>
</tr><tr>
	<th>旗色</th>
	<td>
		<select name="color2">
		$color_b
		</select>
	</td>
</tr><tr>
	<th>アイコン</th>
	<td>
		<div id="Selected"><div class="select"><img id="imgchange" src="$cf{faceurl}/$selecticon" width="80px" height="80px" alt=""></div></div>
		<select name="icon" id="icon" onchange="iconchg();" />
		$op_icon
		</select>
	</td>
</tr><tr>
	<th><span syle="font-size:10.8pt">お天気<br />マーク</span></th>
	<td>
	<div id="weather_selected"><div class="select"><img id="imagechange" src="$cf{weatherurl}/$selectmark" width="47px" height="30px" alt=""></div></div>
		<select name="weather" id="weather" onchange="weatherchg();">
			$op_weather
		</select>
		[<a href="$cf{bbs_cgi}?mode=weather" target="popweather" onclick="popup03('$cf{bbs_cgi}?mode=weather')">Weather MARK Compare</a>]
	</td>
</tr><tr>
	<th>コメント</th>
	<td><textarea name="comment" class="reg-com" rows="6" style="color:gray; border-width:1px; border-color:rgb(255,227,145); border-style:solid;">$com</textarea></td>
EOM

	if ($e1) {
		print qq|</tr><tr>\n|;
		print qq|<th>添付</th><td>\n|;
		print qq|<input type="file" name="upfile1" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-1$e1" target="_blank">添付</a>]&nbsp;\n|;
		print qq|<input type="checkbox" name="del1" value="1">削除</td>\n|;
	} else {
		print qq|<input type="file" name="upfile1" size="36" /><br />\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="25"><br />\n|;
	}

	print <<EOM;
</tr><tr>
	<th>YouTube</th>
	<td>YouTubeタグ [埋め込みコード]<br /><textarea name="youtube" class="reg-com" rows="7">$tube</textarea></td>
</tr><tr>
	<th>YouTube ID</th>
	<td>
		<input type="text" name="tubeid" value="$tubeid" class="reg-com-tube">
		<a href="$cf{bbs_cgi}?mode=expound&sid=$in{sid}" target="expound" onclick="poptube('$cf{bbs_cgi}?mode=expound&sid=$in{sid}')">【YouTube貼付方法】</a>
	</td>
</tr><tr>
	<th>URL</th>
	<td><input type="text" name="url" value="$url" class="reg-url"></td>

EOM

		print qq|</tr><tr>\n|;
		print qq|<th>追加添付</th><td>\n|;
	if ($e2) {
		print qq|１．<input type="file" name="upfile2" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-2$e2" target="_blank">追加 １]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del2" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|１．<input type="file" name="upfile2" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="25"><br /><hr class="edit">\n|;
	}

	if ($e3) {
		print qq|２．<input type="file" name="upfile3" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-3$e3" target="_blank">追加 ２]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del3" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|２．<input type="file" name="upfile3" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="25"><br /><hr class="edit">\n|;
	}

	if ($e4) {
		print qq|３．<input type="file" name="upfile4" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-4$e4" target="_blank">追加 ３]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del4" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|３．<input type="file" name="upfile4" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="25"><br /><hr class="edit">\n|;
	}

	if ($e5) {
		print qq|４．<input type="file" name="upfile5" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-5$e5" target="_blank">追加 ４]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del5" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|４．<input type="file" name="upfile5" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="25"><br /><hr class="edit">\n|;
	}

	if ($e6) {
		print qq|５．<input type="file" name="upfile6" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-6$e6" target="_blank">追加 ５]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del6" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|５．<input type="file" name="upfile6" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="25"><br /><hr class="edit">\n|;
	}

	if ($e7) {
		print qq|６．<input type="file" name="upfile7" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext7" class="reg-imgtxt" placeholder="追加添付６タイトル" value="$imgtxt7" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-7$e7" target="_blank">追加 ６]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del7" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|６．<input type="file" name="upfile7" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext7" class="reg-imgtxt" placeholder="追加添付６タイトル" value="$imgtxt7" size="25"><br /><hr class="edit">\n|;
	}

	if ($e8) {
		print qq|７．<input type="file" name="upfile8" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext8" class="reg-imgtxt" placeholder="追加添付７タイトル" value="$imgtxt8" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-8$e8" target="_blank">追加 ７]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del8" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|７．<input type="file" name="upfile8" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext8" class="reg-imgtxt" placeholder="追加添付７タイトル" value="$imgtxt8" size="25"><br /><hr class="edit">\n|;
	}

	if ($e9) {
		print qq|８．<input type="file" name="upfile9" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext9" class="reg-imgtxt" placeholder="追加添付８タイトル" value="$imgtxt9" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-9$e9" target="_blank">追加 ８]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del9" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|８．<input type="file" name="upfile9" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext9" class="reg-imgtxt" placeholder="追加添付８タイトル" value="$imgtxt9" size="25"><br /><hr class="edit">\n|;
	}

	if ($e10) {
		print qq|９．<input type="file" name="upfile10" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext10" class="reg-imgtxt" placeholder="追加添付９タイトル" value="$imgtxt10" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-10$e10" target="_blank">追加 ９]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del10" value="1">削除<br /><hr class="edit">\n|;
	} else {
		print qq|９．<input type="file" name="upfile10" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext10" class="reg-imgtxt" placeholder="追加添付９タイトル" value="$imgtxt10" size="25"><br /><hr class="edit">\n|;
	}

	if ($e11) {
		print qq|10．<input type="file" name="upfile11" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext11" class="reg-imgtxt" placeholder="追加添付１０タイトル" value="$imgtxt11" size="25">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{diaryimgurl}/$in{no}-11$e11" target="_blank">追加 10]</a>&nbsp;|;
		print qq|<input type="checkbox" name="del11" value="1">削除<br><br>\n|;
		print qq|</td></tr><tr>\n|;
	} else {
		print qq|10．<input type="file" name="upfile11" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|<input type="text" name="imgtext11" class="reg-imgtxt" placeholder="追加添付１０タイトル" value="$imgtxt11" size="25"><br><br>\n|;
	}
	
	print <<EOM;

</tr><tr>
	<th>文字色</th>
	<td>$color</td>
</tr><tr>
	<th></th>
	<td>
	<input type="submit" class="regbtn_admin" value="送信する">
	</td>
</tr>
</table>
</form>
<hr class="bottom">
</div></div>
</body>
</html>
EOM

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  会員管理
#-----------------------------------------------------------
sub members {
	# 新規フォーム
	if ($in{job} eq "new") {

		member_form();

	# 新規発行
	} elsif ($in{job} eq "new2") {

		my $err;
		if (!$in{name}) { $err .= "名前が未入力です<br>\n"; }
		if ($in{myid} =~ /\W/) { $err .= "IDは英数字のみです<br>\n"; }
		if (length($in{myid}) < 4 || length($in{myid}) > 8) {
			$err .= "IDは英数字で4～8文字です<br>\n";
		}
		if ($in{mypw} =~ /\W/) { $err .= "パスワードは英数字のみです<br>\n"; }
		if (length($in{mypw}) < 4 || length($in{mypw}) > 8) {
			$err .= "パスワードは英数字で4～8文字です<br>\n";
		}
		if (!$in{rank}) { $err .= "権限が未選択です<br>\n"; }
		err($err) if ($err);

		# パス暗号化
		my $crypt = encryption($in{mypw});

		# IDチェック
		my ($flg,@data);
		open(DAT,"+< $cf{memfile}") or &err("open err: $cf{memfile}");
		while(<DAT>) {
			my ($id,$pw,$rank,$nam) = split(/<>/);

			if ($in{myid} eq $id) { $flg++; last; }
			push(@data,$_);
		}

		if ($flg) {
			close(DAT);
			err("このIDは既に登録済です");
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT "$in{myid}<>$crypt<>$in{rank}<>$in{name}<>\n";
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 修正フォーム
	} elsif ($in{job} eq "edit" && $in{myid}) {

		my @log;
		open(IN,"$cf{memfile}") or &err("open err: $cf{memfile}");
		while (<IN>) {
			my ($id,$pw,$rank,$nam) = split(/<>/);

			if ($in{myid} eq $id) {
				@log = ($id,$pw,$rank,$nam);
				last;
			}
		}
		close(IN);

		member_form(@log);

	# 修正実行
	} elsif ($in{job} eq "edit2") {

		my ($err,$crypt);
		if (!$in{name}) { $err .= "名前が未入力です<br>\n"; }
		if ($in{myid} =~ /\W/) { $err .= "IDは英数字のみです<br>\n"; }
		if (length($in{myid}) < 4 || length($in{myid}) > 8) {
			$err .= "IDは英数字で4～8文字です<br>\n";
		}
		if ($in{chg}) {
			if ($in{mypw} =~ /\W/) { $err .= "パスワードは英数字のみです<br>\n"; }
			if (length($in{mypw}) < 4 || length($in{mypw}) > 8) {
				$err .= "パスワードは英数字で4～8文字です<br>\n";
			}

			# パス暗号化
			$crypt = encryption($in{mypw});

		} elsif (!$in{chg} && $in{mypw} ne "") {
			$err .= "パスワードの強制変更はチェックボックスに選択してください<br>\n";
		}
		if (!$in{rank}) { $err .= "権限が未選択です<br>\n"; }
		err($err) if ($err);

		my @data;
		open(DAT,"+< $cf{memfile}") or &err("open err: $cf{memfile}");
		while(<DAT>) {
			my ($id,$pw,$rank,$nam) = split(/<>/);

			if ($in{myid} eq $id) {
				if ($crypt) { $pw = $crypt; }
				$_ = "$id<>$pw<>$in{rank}<>$in{name}<>\n";
			}
			push(@data,$_);
		}
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除
	} elsif ($in{job} eq "dele" && $in{myid}) {

		# 削除情報
		my %del;
		foreach ( $cgi->param('myid') ) {
			$del{$_}++;
		}

		my @data;
		open(DAT,"+< $cf{memfile}") or &err("open err: $cf{memfile}");
		while(<DAT>) {
			my ($id,$pw,$rank,$nam) = split(/<>/);
			next if (defined($del{$id}));

			push(@data,$_);
		}
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	header("会員管理");
	print <<"EOM";
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
EOM
	back_btn();
	print <<"EOM";
</div>
<div class="sub-ttl"> 会員管理</div>
<br />
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="members" value="1">
処理 :
<select name="job">
<option value="new">新規
<option value="edit">修正
<option value="dele">削除
</select>
<input type="submit" value="送信する">
<table class="panel">
<tr>
  <th>選択</th>
  <th>ログインID</th>
  <th>名前</th>
  <th>ランク</th>
</tr>
EOM

	open(IN,"$cf{memfile}") or &err("open err: $cf{memfile}");
	while (<IN>) {
		my ($id,$pw,$rank,$nam) = split(/<>/);

		print qq|<tr><td class="ta-c"><input type="radio" name="myid" value="$id"></td>|;
		print qq|<td>$id</td><td>$nam</td><td class="ta-c">$rank</td></tr>\n|;
	}
	close(IN);

	print <<EOM;
</table>
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  会員フォーム
#-----------------------------------------------------------
sub member_form {
	my ($id,$pw,$rank,$nam) = @_;
	my $job = $in{job} . '2';

	header("会員管理 &gt; 登録フォーム");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
EOM
	back_btn();
	print <<"EOM";
</div>
<div class="sub-ttl"> 会員管理 &gt; 登録フォーム</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="members" value="1">
<input type="hidden" name="job" value="$job">
<table class="panel">
<tr>
	<th>名前</th>
	<td><input type="text" name="name" size="25" value="$nam" style="color:gray; border-width:1px; border-color:rgb(255,227,145); border-style:solid;"></td>
</tr><tr>
	<th>ログインID</th>
	<td>
EOM

	if ($in{myid}) {
		print qq|<b>$in{myid}</b>|;
	} else {
		print qq|<input type="text" name="myid" size="10" value="$id" style="color:gray; border-width:1px; border-color:rgb(255,227,145); border-style:solid;">\n|;
		print qq|<span style="font-size:10pt">（英数字で4～8文字）</span>\n|;
	}

	print <<EOM;
	</td>
</tr><tr>
	<th>パスワード</th>
	<td>
		<input type="password" name="mypw" size="10" style="color:gray; border-width:1px; border-color:rgb(255,227,145); border-style:solid;">
		<span style="font-size:10pt">（英数字で4～8文字）</span>
EOM

	if ($in{myid}) {
		print qq|<br><input type="checkbox" name="chg" value="1">\n|;
		print qq|パスワードを強制変更する場合にチェック\n|;
		print qq|<input type="hidden" name="myid" value="$in{myid}" style="color:gray; border-width:1px; border-color:rgb(255,227,145); border-style:solid;">\n|;
	}

	print <<EOM;
	</td>
</tr><tr>
	<th>権限</th>
	<td>
EOM

	my %rank = (1 => "閲覧のみ", 2 => "閲覧&amp;書込OK");
	foreach (1,2) {
		if ($rank == $_) {
			print qq|<input type="radio" name="rank" value="$_" checked>レベル$_ ($rank{$_})<br>\n|;
		} else {
			print qq|<input type="radio" name="rank" value="$_">レベル$_ ($rank{$_})<br>\n|;
		}
	}

	print <<EOM;
	</td>
</tr>
</table>
<input type="submit" value="送信する">
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  セッションファイル掃除
#-----------------------------------------------------------
sub exp_ses {
	# 実行
	if ($in{submit}) {

		# 期限切れファイルを削除
		CGI::Session::ExpireSessions -> new(temp_dir => $cf{sesdir}, delta => $in{delta})->expire_file_sessions();

		# 完了画面
		&msg_expses;
	}

	# デフォルト
	my $delta = $cf{authtime} + 10;

	header("セッションファイル掃除");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="right">
EOM
	back_btn();
	print <<"EOM";
</div>
<div class="sub-ttl"> セッションファイル掃除</div>
<p>
	・利用者がログイン後、ログオフせずにブラウザを閉じると、不要なセッションファイルが蓄積されます。<br>
	・定期的に、不要なセッションファイルを掃除するようにしましょう。<br>
</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="exp_ses" value="1">
<table class="panel">
<tr>
	<th>未更新ファイル：</th>
	<td>
		<input type="text" name="delta" size="5" value="$delta"> <span style="font-size:10pt">分以上のものを削除</span><br />
		<span style="font-size:10pt">（ログイン認証後の設定時間<br /><b>$cf{job_time}</b>分以上で設定すること）</span>
	</td>
</tr>
</table>
<input type="submit" name="submit" value=" 実行する ">
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ユーザー登録アイコン・リスト挿入
#-----------------------------------------------------------
sub put_iconlist{

	my @log;
	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<IN>) {
		push(@log,$_);
	}
	close(IN);
	foreach (@log) {
		my ($no,$date,$nam,$sub,$com,$hos,$pw,$ex,$w,$h,$only) = split(/<>/);

		if ($only) { 
			$only = "（$nam 様専用）"; 
		} else { 
			$only = "（共用アイコン）";
		}

		push(@{$cf{icon}},"$no$ex,<span style=\"color:#008db7\">＊ $sub$only</span>") if ($cf{user_icon});
	}
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script src="$cf{cmnurl}/bbs.js"></script>
<script type="text/javascript"> 
var ua = navigator.userAgent;
if(ua.indexOf('iPhone') != -1 || ua.indexOf('Android') != -1){
//iPhone & Android
document.write('<link rel="stylesheet" href="cmn/admin-mobile.css">');
}else{
//PC
document.write('<link rel="stylesheet" href="cmn/admin.css">');
}
</script>
<script type="text/javascript" src="./cmn/footerFixed_modified.js"></script>
<title>$ttl</title>
</head>
<body>
EOM
}

#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub add_upload {
	my $num = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	my @ret;
	foreach my $i (1 .. 11) {

		# mimeタイプ
		my $mime = $cgi->param_mime("upfile$i");

		# 拡張子取得
		my $fname = $cgi->param_filename("upfile$i");
		if ($fname =~ /(\.jpe?g|\.png|\.gif|\.pdf|\.txt|\.doc|\.docx|\.xls|\.xlsx|\.ppt|\.pptx|\.zip|\.mp3|\.mp4)$/i) {
			my $ex = $1;
			$ex =~ tr/A-Z/a-z/;
			if ($ex eq '.jpeg') { $ex = '.jpg'; }

			# 整合性チェック
			my $flg;
			if ($cf{ok_gif}) {
				if ($mime =~ /^image\/gif$/i and $ex eq '.gif') { $flg++; }
			}
			if (!$flg and $cf{ok_jpeg}) {
				if ($mime =~ /^image\/p?jpe?g$/i and $ex eq '.jpg') { $flg++; }
			}
			if (!$flg and $cf{ok_png}) {
				if ($mime =~ /^image\/(x-)?png$/i and $ex eq '.png') { $flg++; }
			}
			if (!$flg and $cf{ok_pdf}) {
				if ($mime =~ /^application\/pdf$/i and $ex eq '.pdf') { $flg++; }
			}
			if (!$flg and $cf{ok_zip}) {
				if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ex eq '.zip') { $flg++; }
			}
			if (!$flg and $cf{ok_text}) {
				if ($mime =~ /^text\/plain$/i and $ex =~ /^\.te?xt$/) { $flg++; }
			}
			if (!$flg and $cf{ok_word}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ex eq '.doc') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ex eq '.docx') { $flg++; }
			}
			if (!$flg and $cf{ok_excel}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ex eq '.xls') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ex eq '.xlsx') { $flg++; }
			}
			if (!$flg and $cf{ok_ppt}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ex eq '.ppt') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ex eq '.pptx') { $flg++; }
			}
			if (!$flg and $cf{ok_mp3}) {
				if ($mime =~ /^audio\/mpeg$/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mp3/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mpg/i and $ex eq '.mp3') { $flg++; }
			}
			if (!$flg and $cf{ok_mp4}) {
				if ($mime =~ /^video\/mpeg$/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mp4/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mpg/i and $ex eq '.mp4') { $flg++; }
			}
			if (!$flg) { error('このファイルは取り扱いできません'); }

		# 添付ファイル定義
		my $upfile = "$cf{imgdir}/$num-$i$ex";

		# アップロード書き込み
		open(UP,"+> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);

		# パーミッション付与
		chmod(0666,$upfile);

		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ex eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ex eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ex eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{imgdir}/$num-s-$i$ex";
			make_thumb($upfile,$thumb,$w,$h);
		}

		# 拡張子, 横幅, 縦幅 の順
			push(@ret,($ex,$w,$h));
		} else {
			push(@ret,('','',''));
		}
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  ダイアリー添付アップロード
#-----------------------------------------------------------
sub diary_upload {
	my $num = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	my @ret;
	foreach my $i (1 .. 11) {

		# mimeタイプ
		my $mime = $cgi->param_mime("upfile$i");

		# 拡張子取得
		my $fname = $cgi->param_filename("upfile$i");
		if ($fname =~ /(\.jpe?g|\.png|\.gif|\.pdf|\.txt|\.doc|\.docx|\.xls|\.xlsx|\.ppt|\.pptx|\.zip|\.mp3|\.mp4)$/i) {
			my $ex = $1;
			$ex =~ tr/A-Z/a-z/;
			if ($ex eq '.jpeg') { $ex = '.jpg'; }

			# 整合性チェック
			my $flg;
			if ($cf{ok_gif}) {
				if ($mime =~ /^image\/gif$/i and $ex eq '.gif') { $flg++; }
			}
			if (!$flg and $cf{ok_jpeg}) {
				if ($mime =~ /^image\/p?jpe?g$/i and $ex eq '.jpg') { $flg++; }
			}
			if (!$flg and $cf{ok_png}) {
				if ($mime =~ /^image\/(x-)?png$/i and $ex eq '.png') { $flg++; }
			}
			if (!$flg and $cf{ok_pdf}) {
				if ($mime =~ /^application\/pdf$/i and $ex eq '.pdf') { $flg++; }
			}
			if (!$flg and $cf{ok_zip}) {
				if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ex eq '.zip') { $flg++; }
			}
			if (!$flg and $cf{ok_text}) {
				if ($mime =~ /^text\/plain$/i and $ex =~ /^\.te?xt$/) { $flg++; }
			}
			if (!$flg and $cf{ok_word}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ex eq '.doc') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ex eq '.docx') { $flg++; }
			}
			if (!$flg and $cf{ok_excel}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ex eq '.xls') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ex eq '.xlsx') { $flg++; }
			}
			if (!$flg and $cf{ok_ppt}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ex eq '.ppt') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ex eq '.pptx') { $flg++; }
			}
			if (!$flg and $cf{ok_mp3}) {
				if ($mime =~ /^audio\/mpeg$/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mp3/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mpg/i and $ex eq '.mp3') { $flg++; }
			}
			if (!$flg and $cf{ok_mp4}) {
				if ($mime =~ /^video\/mpeg$/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mp4/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mpg/i and $ex eq '.mp4') { $flg++; }
			}
			if (!$flg) { error('このファイルは取り扱いできません'); }

		# 添付ファイル定義
		my $upfile = "$cf{diaryimgdir}/$num-$i$ex";

		# アップロード書き込み
		open(UP,"+> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);

		# パーミッション付与
		chmod(0666,$upfile);

		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ex eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ex eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ex eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{diaryimgdir}/$num-s-$i$ex";
			make_thumb($upfile,$thumb,$w,$h);
		}

		# 拡張子, 横幅, 縦幅 の順
			push(@ret,($ex,$w,$h));
		} else {
			push(@ret,('','',''));
		}
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  修正完了メッセージ
#-----------------------------------------------------------
sub msg_edit {
	header("修正完了");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div class="all">
<div id="main">
<div id="main-in">
<div class="sub-ttl">■修正完了</div>
<p align="center">
<h5 align="center">修正を完了しました</h5>
<div align="center">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_log" value="1">
<input type="submit" value="記事メンテナンスに戻る" style="width:200px;" >
</form>
</div></div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ダイアリー記事修正完了メッセージ
#-----------------------------------------------------------
sub diary_edit {
	header("ダイアリー記事修正完了");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div class="all">
<div id="main">
<div id="main-in">
<div class="sub-ttl">■ ダイアリー記事修正完了</div>
<p align="center">
<h5 align="center">ダイアリー記事の修正を完了しました</h5>
<div align="center">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="diary_mente" value="1">
<input type="submit" value="ダイアリー記事メンテナンスに戻る" style="width:300px;" >
</form>
</div></div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  タグ復元
#-----------------------------------------------------------
sub chg_tag {
	local($_) = @_;
	
	s/&amp;/&/g;
	s/&quot;/"/g;
	s/&lt;/</g;
	s/&gt;/>/g;
	s/&#39;/'/g;
	$_;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	header("完了");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div class="all">
<div id="main">
<div id="main-in">
<div align="center" style="margin-top:3em;">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<br>
<input type="submit" value="管理メニューに戻る" class="small button" />
</form>
</div>
</div></div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  掃除完了メッセージ
#-----------------------------------------------------------
sub msg_expses {
	header("掃除完了");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div class="all">
<div id="main">
<div id="main-in">
<p class="sub-ttl">■掃除完了</p>
<h4>不要なセッションファイルの削除を完了しました</h4>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="管理メニュー" >
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my ($mode) = @_;

	print <<EOM;
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面">| : '' ]}
<input type="submit" value="▲メニュー" >
</form>
</div>
EOM
}

#-----------------------------------------------------------
#  crypt暗号
#-----------------------------------------------------------
sub encryption {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub err {
	my $err = shift;

	header("ERROR");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div class="all">
<div id="main">
<div id="main-in">
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="red">$err</p>
<hr width="350">
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="https://www.kent-web.com/" target="_top">Joyful Note</a> -<br />
	- <a href="https://www.transformsite.com/" target="_top">$cf{version}</a> -<br>
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  文字カット for UTF-8
#-----------------------------------------------------------
sub cut_str {
	my ($str,$all) = @_;
	$str =~ s|<br( /)?>||g;
	
	my $i = 0;
	my ($ret,$flg);
	while ($str =~ /([\x00-\x7f]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/gx) {
		$i++;
		$ret .= $1;
		if ($i >= $all) {
			$flg++;
			last;
		}
	}
	$ret .= '...' if ($flg);
	
	return $ret;
}

